-- ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
-- Written by Kimberly L. Tripp
-- 
-- For more scripts and sample code, check out 
-- 	http://www.SQLSkills.com
--
-- Disclaimer - Thoroughly test this script, execute at your own risk.
-- ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

USE [Credit];
GO

CREATE PROC [getmember_param] 
    @ln varchar(15)
AS
SELECT * 
FROM [dbo].[member] AS [m]
WHERE [m].[lastname] = @ln; -- parameter CAN be sniffed (specific plan)
go

CREATE PROC [getmember_var]
    @ln varchar(15)
AS
DECLARE @lname varchar(15);
SET @lname = @ln;
SELECT * 
FROM [dbo].[member] AS [m]
WHERE [m].[lastname] = @lname; -- variable IS UNKNOWN (average plan)
go

CREATE PROC [getmember_opt] 
    @ln varchar(15)
AS
SELECT * 
FROM [dbo].[member] AS [m]
WHERE [m].[lastname] = @ln 
OPTION (OPTIMIZE FOR UNKNOWN) -- average plan checking density_vector (same as UNKNOWN)
go
